﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class PlayerController : MonoBehaviour
{
    public Rigidbody rb;
    public float ypos;
    public float zpos;

    public bool canMove;
    public bool canPeek;
    public Camera main;
    public Camera top;

    public GameObject red;
    public GameObject orange;
    public GameObject yellow;
    public GameObject green;
    public GameObject blue;
    public GameObject violet;
    public GameObject pink;

    public int r;
    public int o;
    public int y;
    public int g;
    public int b;
    public int v;
    public int p;
    public int c;
    public int j;

    public static int count;

    public float timer;

    public TextMesh endText;


    void Start()
    {
        rb = GetComponent<Rigidbody>();

        main.enabled = true;
        top.enabled = false;
        canMove = true;
        canPeek = false;

        count = 0;

        r = 0;
        o = 0;
        y = 0;
        g = 0;
        b = 0;
        v = 0;
        p = 0;
        c = 0;
        j = 0;

        timer = 0f;
    }


    void Update()
    {
        zpos = transform.position.z;
        if(zpos < -50 && canMove)
        {
            canMove = false;
            DisplayEnd();
        }

        if (Input.GetKeyDown(KeyCode.C))
        {
            if (canPeek)
            {
                if (canMove)
                {
                    main.enabled = false;
                    top.enabled = true;
                    canMove = false;
                    c += 1;
                }
                else
                {
                    main.enabled = true;
                    top.enabled = false;
                    canMove = true;
                    canPeek = false;
                }
            }
        }

        if (Input.GetKeyDown(KeyCode.J))
            {
                ypos = transform.position.y;
                if(ypos < 1f)
                {
                    rb.AddForce(new Vector3(0, 180, 0), ForceMode.Impulse);
                    j += 1;
                }
            }

        if (Input.GetKeyDown(KeyCode.H))
        {
            SceneManager.LoadScene("Controls");
        }

        if (canMove)
        {
            if (Input.GetKeyDown(KeyCode.R))
            {
                DropCrumb(red);
                r += 1;
            }

            if (Input.GetKeyDown(KeyCode.O))
            {
                DropCrumb(orange);
                o += 1;
            }

            if (Input.GetKeyDown(KeyCode.Y))
            {
                DropCrumb(yellow);
                y += 1;
            }

            if (Input.GetKeyDown(KeyCode.G))
            {
                DropCrumb(green);
                g += 1;
            }

            if (Input.GetKeyDown(KeyCode.B))
            {
                DropCrumb(blue);
                b += 1;
            }

            if (Input.GetKeyDown(KeyCode.V))
            {
                DropCrumb(violet);
                v += 1;
            }

            if (Input.GetKeyDown(KeyCode.P))
            {
                DropCrumb(pink);
                p += 1;
            }
        }

        timer += Time.deltaTime;
    }


    void FixedUpdate()
    {
        if (canMove)
        {
            float mov = Input.GetAxis("Vertical");
            float rot = Input.GetAxis("Horizontal");
            float rot_now = transform.eulerAngles.y;

            Vector3 move = new Vector3(-mov * 10 * Mathf.Sin(rot_now * Mathf.PI / 180), 0.0f, -mov * 10 * Mathf.Cos(rot_now * Mathf.PI / 180));
            rb.MovePosition(transform.position + move * Time.fixedDeltaTime);

            Vector3 rotate = new Vector3(0.0f, rot * 100, 0.0f);
            Quaternion dR = Quaternion.Euler(rotate * Time.fixedDeltaTime);
            rb.MoveRotation(rb.rotation * dR);
        }
    }


    void DropCrumb(GameObject color)
    {
        float rotNow = transform.eulerAngles.y;
        Vector3 spawnPos = transform.position + new Vector3(Mathf.Sin(rotNow * Mathf.PI / 180), 3.0f, Mathf.Cos(rotNow * Mathf.PI / 180));

        GameObject crumb;
        crumb = Instantiate(color) as GameObject;
        crumb.transform.position = spawnPos;

        if (!(canPeek))
        {
            canPeek = true;
        }
    }

    void DisplayEnd()
    {
        GameObject end = GameObject.Find("End");
        end.transform.GetComponent<TMPro.TextMeshProUGUI>().text = " red crumbs: " + r + "\n orange crumbs: " + o + "\n yellow crumbs: " + y + "\n green crumbs: " + g + "\n blue crumbs: " + b + "\n violet crumbs: " + v + "\n pink crumbs: " + p + "\n\n camera switches: " + c + "\n jumps: " + j + "\n\n days passed: " + timer / 360f;
        end.SetActive(true);
    }
}
